| Flutter Linux Embedder |

Functions
fl_plugin_registrar.cc File Reference
`#include "flutter/shell/platform/linux/public/flutter_linux/fl_plugin_registrar.h"`
`#include "flutter/shell/platform/linux/fl_plugin_registrar_private.h"`
`#include <gmodule.h>`

Go to the source code of this file.

## Functions
| G_DECLARE_FINAL_TYPE (FlPluginRegistrarImpl, fl_plugin_registrar_impl, FL, PLUGIN_REGISTRAR_IMPL, GObject) struct _FlPluginRegistrarImpl
static void | fl_plugin_registrar_impl_iface_init (FlPluginRegistrarInterface *iface)
| G_DEFINE_TYPE_WITH_CODE (FlPluginRegistrarImpl, fl_plugin_registrar_impl, G_TYPE_OBJECT, G_IMPLEMENT_INTERFACE(fl_plugin_registrar_get_type(), fl_plugin_registrar_impl_iface_init)) static void fl_plugin_registrar_default_init(FlPluginRegistrarInterface *iface)
static void | fl_plugin_registrar_impl_dispose (GObject *object)
static void | fl_plugin_registrar_impl_class_init (FlPluginRegistrarImplClass *klass)
static FlBinaryMessenger * | get_messenger (FlPluginRegistrar *registrar)
static FlTextureRegistrar * | get_texture_registrar (FlPluginRegistrar *registrar)
static FlView * | get_view (FlPluginRegistrar *registrar)
static void | fl_plugin_registrar_impl_init (FlPluginRegistrarImpl *self)
FlPluginRegistrar * | fl_plugin_registrar_new (FlView *view, FlBinaryMessenger *messenger, FlTextureRegistrar *texture_registrar)
G_MODULE_EXPORT FlBinaryMessenger * | fl_plugin_registrar_get_messenger (FlPluginRegistrar *self)
G_MODULE_EXPORT FlTextureRegistrar * | fl_plugin_registrar_get_texture_registrar (FlPluginRegistrar *self)
G_MODULE_EXPORT FlView * | fl_plugin_registrar_get_view (FlPluginRegistrar *self)

## Function Documentation

## ◆ fl_plugin_registrar_get_messenger()

G_MODULE_EXPORT FlBinaryMessenger* fl_plugin_registrar_get_messenger | ( | FlPluginRegistrar * | registrar | ) |

FlPluginRegistrar:

#FlPluginRegistrar is used when registering new plugins. fl_plugin_registrar_get_messenger: @registrar: an #FlPluginRegistrar.

Gets the messenger this plugin can communicate with.

Returns: an #FlBinaryMessenger.

Definition at line 113 of file fl_plugin_registrar.cc.

114 {
115 g_return_val_if_fail(FL_IS_PLUGIN_REGISTRAR(self), nullptr);
116
117 return FL_PLUGIN_REGISTRAR_GET_IFACE(self)->get_messenger(self);
118 }

Referenced by TEST().

## ◆ fl_plugin_registrar_get_texture_registrar()

G_MODULE_EXPORT FlTextureRegistrar* fl_plugin_registrar_get_texture_registrar | ( | FlPluginRegistrar * | registrar | ) |

fl_plugin_registrar_get_texture_registrar: @registrar: an #FlPluginRegistrar.

Gets the texture registrar this plugin can communicate with.

Returns: an #FlTextureRegistrar.

Definition at line 120 of file fl_plugin_registrar.cc.

121 {
122 g_return_val_if_fail(FL_IS_PLUGIN_REGISTRAR(self), nullptr);
123
124 return FL_PLUGIN_REGISTRAR_GET_IFACE(self)->get_texture_registrar(self);
125 }

Referenced by TEST().

## ◆ fl_plugin_registrar_get_view()

G_MODULE_EXPORT FlView* fl_plugin_registrar_get_view | ( | FlPluginRegistrar * | registrar | ) |

fl_plugin_registrar_get_view: @registrar: an #FlPluginRegistrar.

Get the view that Flutter is rendering with.

Returns: (allow-none): an #FlView or NULL if running in headless mode.

Definition at line 127 of file fl_plugin_registrar.cc.

127 {
128 g_return_val_if_fail(FL_IS_PLUGIN_REGISTRAR(self), nullptr);
129
130 return FL_PLUGIN_REGISTRAR_GET_IFACE(self)->get_view(self);
131 }

## ◆ fl_plugin_registrar_impl_class_init()

static void fl_plugin_registrar_impl_class_init | ( | FlPluginRegistrarImplClass * | klass | ) |
| static

Definition at line 58 of file fl_plugin_registrar.cc.

59 {
60 G_OBJECT_CLASS(klass)->dispose = fl_plugin_registrar_impl_dispose;
61 }

References fl_plugin_registrar_impl_dispose().

## ◆ fl_plugin_registrar_impl_dispose()

static void fl_plugin_registrar_impl_dispose | ( | GObject * | object | ) |
| static

Definition at line 44 of file fl_plugin_registrar.cc.

44 {
45 FlPluginRegistrarImpl* self = FL_PLUGIN_REGISTRAR_IMPL(object);
46
47 if (self->view != nullptr) {
48 g_object_remove_weak_pointer(G_OBJECT(self->view),
49 reinterpret_cast<gpointer*>(&(self->view)));
50 self->view = nullptr;
51 }
52 g_clear_object(&self->messenger);
53 g_clear_object(&self->texture_registrar);
54
55 G_OBJECT_CLASS(fl_plugin_registrar_impl_parent_class)->dispose(object);
56 }

References self.

Referenced by fl_plugin_registrar_impl_class_init().

## ◆ fl_plugin_registrar_impl_iface_init()

static void fl_plugin_registrar_impl_iface_init | ( | FlPluginRegistrarInterface * | iface | ) |
| static

Definition at line 78 of file fl_plugin_registrar.cc.

79 {
80 iface->get_messenger = get_messenger;
81 iface->get_texture_registrar = get_texture_registrar;
82 iface->get_view = get_view;
83 }

References get_messenger(), get_texture_registrar(), and get_view().

## ◆ fl_plugin_registrar_impl_init()

static void fl_plugin_registrar_impl_init | ( | FlPluginRegistrarImpl * | self | ) |
| static

Definition at line 85 of file fl_plugin_registrar.cc.

85 {}

## ◆ fl_plugin_registrar_new()

FlPluginRegistrar* fl_plugin_registrar_new | ( | FlView * | view,
|  | FlBinaryMessenger * | messenger,
|  | FlTextureRegistrar * | texture_registrar
| ) |  |

fl_plugin_registrar_new: @view: (allow-none): the #FlView that is being plugged into or NULL for headless mode. @messenger: the #FlBinaryMessenger to communicate with. @texture_registrar: the #FlTextureRegistrar to communicate with.

Creates a new #FlPluginRegistrar.

Returns: a new #FlPluginRegistrar.

Definition at line 87 of file fl_plugin_registrar.cc.

90 {
91 g_return_val_if_fail(view == nullptr || FL_IS_VIEW(view), nullptr);
92 g_return_val_if_fail(FL_IS_BINARY_MESSENGER(messenger), nullptr);
93 g_return_val_if_fail(FL_IS_TEXTURE_REGISTRAR(texture_registrar), nullptr);
94
95 FlPluginRegistrarImpl* self = FL_PLUGIN_REGISTRAR_IMPL(
96 g_object_new(fl_plugin_registrar_impl_get_type(), nullptr));
97
98 // Added to stop compiler complaining about an unused function.
99 FL_IS_PLUGIN_REGISTRAR_IMPL(self);
100
101 self->view = view;
102 if (view != nullptr) {
103 g_object_add_weak_pointer(G_OBJECT(view),
104 reinterpret_cast<gpointer*>(&(self->view)));
105 }
106 self->messenger = FL_BINARY_MESSENGER(g_object_ref(messenger));
107 self->texture_registrar =
108 FL_TEXTURE_REGISTRAR(g_object_ref(texture_registrar));
109
110 return FL_PLUGIN_REGISTRAR(self);
111 }

References g_object_add_weak_pointer(), and self.

Referenced by fl_engine_get_registrar_for_plugin(), and fl_view_get_registrar_for_plugin().

## ◆ G_DECLARE_FINAL_TYPE()

G_DECLARE_FINAL_TYPE | ( | FlPluginRegistrarImpl | ,
|  | fl_plugin_registrar_impl | ,
|  | FL | ,
|  | PLUGIN_REGISTRAR_IMPL | ,
|  | GObject |
| ) |  |

Definition at line 10 of file fl_plugin_registrar.cc.

16 {
17 GObject parent_instance;
18
19 // View that plugin is controlling.
20 FlView* view;
21
22 // Messenger to communicate on.
23 FlBinaryMessenger* messenger;
24
25 // Texture registrar in use.
26 FlTextureRegistrar* texture_registrar;
27 };

## ◆ G_DEFINE_TYPE_WITH_CODE()

G_DEFINE_TYPE_WITH_CODE | ( | FlPluginRegistrarImpl | ,
|  | fl_plugin_registrar_impl | ,
|  | G_TYPE_OBJECT | ,
|  | G_IMPLEMENT_INTERFACE(fl_plugin_registrar_get_type(), fl_plugin_registrar_impl_iface_init) |
| ) |  |

Definition at line 34 of file fl_plugin_registrar.cc.

42 {}

## ◆ get_messenger()

static FlBinaryMessenger* get_messenger | ( | FlPluginRegistrar * | registrar | ) |
| static

Definition at line 63 of file fl_plugin_registrar.cc.

63 {
64 FlPluginRegistrarImpl* self = FL_PLUGIN_REGISTRAR_IMPL(registrar);
65 return self->messenger;
66 }

Referenced by fl_plugin_registrar_impl_iface_init().

## ◆ get_texture_registrar()

static FlTextureRegistrar* get_texture_registrar | ( | FlPluginRegistrar * | registrar | ) |
| static

Definition at line 68 of file fl_plugin_registrar.cc.

68 {
69 FlPluginRegistrarImpl* self = FL_PLUGIN_REGISTRAR_IMPL(registrar);
70 return self->texture_registrar;
71 }

Referenced by fl_plugin_registrar_impl_iface_init().

## ◆ get_view()

static FlView* get_view | ( | FlPluginRegistrar * | registrar | ) |
| static

Definition at line 73 of file fl_plugin_registrar.cc.

73 {
74 FlPluginRegistrarImpl* self = FL_PLUGIN_REGISTRAR_IMPL(registrar);
75 return self->view;
76 }

Referenced by fl_plugin_registrar_impl_iface_init().

g_object_add_weak_pointer
g_object_add_weak_pointer(G_OBJECT(self), reinterpret_cast< gpointer * >(&self->engine))
fl_plugin_registrar_impl_dispose
static void fl_plugin_registrar_impl_dispose(GObject *object)
Definition: fl_plugin_registrar.cc:44
self
GdkEvent FlView * self
Definition: fl_view.cc:100
get_view
static FlView * get_view(FlPluginRegistrar *registrar)
Definition: fl_plugin_registrar.cc:73
get_texture_registrar
static FlTextureRegistrar * get_texture_registrar(FlPluginRegistrar *registrar)
Definition: fl_plugin_registrar.cc:68
get_messenger
static FlBinaryMessenger * get_messenger(FlPluginRegistrar *registrar)
Definition: fl_plugin_registrar.cc:63